How to fix path in third-party libs which usage another third-party libs after macdeployqt?



  • Hi everyone! I have a question about deploy app with third-party lib on macOS. I have a project with a few third-party libs. And I use macdeployqt tool from Qt bin folder. This tool is coping all libs to target app bundle. That’s works fine. But in my project one third-party lib is using another lib. All libs was copied to app bundle but app doesn’t work on customer mac, because app can’t find lib. I found the problem. Some of third-party lib is usage gnutls and this is using nettle lib. When macdeployqt tool copy libs they have incorrect path. I can use install_name_tool to fix this. How I can do this recursive for all libs? Maybe some of you has a script for this? Thanks for any help.



  • So, you're defining all the libraries in the .pro file?



  • Not all. Because my application is building correct without add all libs. But I try this. Thanks.



  • @Charlie_Hdz I check it. And still have a problem.

    The result of tool -l command for application binary file looks like:

    andrewsh$ otool -L /Volumes/HPDD/PROJECTS/QtProjects/GIT/iOS_Device_Manager/qt/build-MatterPortBackup-Desktop_Qt_5_10_0_clang_64bit2-Production/Xtended\ Backup\ Manager.app/Contents/MacOS/Xtended\ Backup\ Manager 
    /Volumes/HPDD/PROJECTS/QtProjects/GIT/iOS_Device_Manager/qt/build-MatterPortBackup-Desktop_Qt_5_10_0_clang_64bit2-Production/Xtended Backup Manager.app/Contents/MacOS/Xtended Backup Manager:
    	/System/Library/Frameworks/Foundation.framework/Versions/C/Foundation (compatibility version 300.0.0, current version 1450.15.0)
    	/System/Library/Frameworks/CoreFoundation.framework/Versions/A/CoreFoundation (compatibility version 150.0.0, current version 1450.15.0)
    	@loader_path/../Frameworks/libplist.3.dylib (compatibility version 5.0.0, current version 5.0.0)
    	@loader_path/../Frameworks/libimobiledevice.6.dylib (compatibility version 7.0.0, current version 7.0.0)
    	@loader_path/../Frameworks/libgnutls.30.dylib (compatibility version 45.0.0, current version 45.8.0)
    	@loader_path/../Frameworks/libnettle.6.dylib (compatibility version 6.0.0, current version 6.4.0)
    	@loader_path/../Frameworks/libhogweed.4.dylib (compatibility version 4.0.0, current version 4.4.0)
    	@rpath/QtQuick.framework/Versions/5/QtQuick (compatibility version 5.10.0, current version 5.10.0)
    	@rpath/QtQml.framework/Versions/5/QtQml (compatibility version 5.10.0, current version 5.10.0)
    	@rpath/QtNetwork.framework/Versions/5/QtNetwork (compatibility version 5.10.0, current version 5.10.0)
    	@rpath/QtCore.framework/Versions/5/QtCore (compatibility version 5.10.0, current version 5.10.0)
    	/System/Library/Frameworks/DiskArbitration.framework/Versions/A/DiskArbitration (compatibility version 1.0.0, current version 1.0.0)
    	/System/Library/Frameworks/IOKit.framework/Versions/A/IOKit (compatibility version 1.0.0, current version 275.0.0)
    	@rpath/QtGui.framework/Versions/5/QtGui (compatibility version 5.10.0, current version 5.10.0)
    	@rpath/QtWidgets.framework/Versions/5/QtWidgets (compatibility version 5.10.0, current version 5.10.0)
    	/System/Library/Frameworks/OpenGL.framework/Versions/A/OpenGL (compatibility version 1.0.0, current version 1.0.0)
    	/System/Library/Frameworks/AGL.framework/Versions/A/AGL (compatibility version 1.0.0, current version 1.0.0)
    	/usr/lib/libc++.1.dylib (compatibility version 1.0.0, current version 400.9.0)
    	/usr/lib/libSystem.B.dylib (compatibility version 1.0.0, current version 1252.0.0)
    	/usr/lib/libobjc.A.dylib (compatibility version 1.0.0, current version 228.0.0)
    

    When I try to open my application on customer Mac I receive error:

    dyld: Library not loaded: /usr/local/Cellar/nettle/3.4/lib/libnettle.6.dylib
      Referenced from: /Volumes/HPDD/PROJECTS/QtProjects/GIT/iOS_Device_Manager/qt/build-MatterPortBackup-Desktop_Qt_5_10_0_clang_64bit2-Production/Xtended Backup Manager.app/Contents/Frameworks/libhogweed.4.dylib
      Reason: image not found
    Abort trap: 6
    

    But, as you can see the library libhogweed and libnettle has correct path for application binary file. If I try to use tool -l for library libhogweed I get this result:

    andrewsh$ otool -L /Volumes/HPDD/PROJECTS/QtProjects/GIT/iOS_Device_Manager/qt/build-MatterPortBackup-Desktop_Qt_5_10_0_clang_64bit2-Production/Xtended\ Backup\ Manager.app/Contents/Frameworks/libhogweed.4.dylib 
    /Volumes/HPDD/PROJECTS/QtProjects/GIT/iOS_Device_Manager/qt/build-MatterPortBackup-Desktop_Qt_5_10_0_clang_64bit2-Production/Xtended Backup Manager.app/Contents/Frameworks/libhogweed.4.dylib:
    	@executable_path/../Frameworks/libhogweed.4.dylib (compatibility version 4.0.0, current version 4.4.0)
    	/usr/local/Cellar/nettle/3.4/lib/libnettle.6.dylib (compatibility version 6.0.0, current version 6.4.0)
    	@loader_path/libgmp.10.dylib (compatibility version 14.0.0, current version 14.2.0)
    	/usr/lib/libSystem.B.dylib (compatibility version 1.0.0, current version 1252.0.0)
    

    As you can see the problem in incorrect path for libhogweed which usage libnettle.



  • Has your computer this library path, right?

    /Volumes/HPDD/PROJECTS/QtProjects/GIT/iOS_Device_Manager/qt/build-MatterPortBackup-Desktop_Qt_5_10_0_clang_64bit2-Production/Xtended
    

    Does your customer Mac has the same path?



  • No. This example from my another Mac where I have the same path for application.



  • Ok, maybe you need to explicitly set the libraries path from your customer, also, maybe they're being shared implicitly.



  • Ok, I will try to find another way how to fix the path for customer.


  • Lifetime Qt Champion

    Hi,

    You should run ma deploy Qt with the verbose option on to see what is happening with these external libraries.

    If it’s only this one you can copy it by hand and run install_name_tool on it.



  • Hello
    i have actually same problem with same Library :

    Dyld Error Message:
      Library not loaded: /usr/local/Cellar/nettle/3.3/lib/libnettle.6.dylib
      Referenced from: /private/var/folders/8h/6gwsfzvd0497x5v7dqkf6dg80000gp/T/AppTranslocation/AC4CC981-7245-4236-9929-4EF95D0225B1/d/StoreUpgradeTools.app/Contents/Frameworks/libhogweed.4.dylib
      Reason: image not found
    

    Did you fixe it ?



  • @florent_lightingsoft
    Yes, but you need to do this for every lib which generate this error.

    install_name_tool -change "old_path" "@executable_path/../Frameworks/lib_name" lib_path_for_update
    install_name_tool -change "old_path" "@executable_path/../Frameworks/lib_name" app_binnary_path_for_update
    

    If you find a way to use this commands for all lib and sub-libs by script let me know, because for now I use this for every lib manually.


Log in to reply
 

Looks like your connection to Qt Forum was lost, please wait while we try to reconnect.